
--Create our needed frames and what not.
CreateFrame("Button", "WorldStateScoreFrameTab4", WorldStateScoreFrame, "CharacterFrameTabButtonTemplate");
WorldStateScoreFrameTab4:SetID(4);
WorldStateScoreFrameTab4:SetText("Servers");
WorldStateScoreFrameTab4:SetPoint("LEFT", "WorldStateScoreFrameTab3", "RIGHT", -16,0);
WorldStateScoreFrameTab4:SetScript("OnClick",WorldStateScoreFrameTab_OnClick);
PanelTemplates_SetNumTabs(WorldStateScoreFrame, 4);


CreateFrame("Frame", "WorldStateServerScoreFrame1", WorldStateScoreFrame, "WorldStateScoreTemplate");
WorldStateServerScoreFrame1:SetID(1);

WorldStateServerScoreFrame1:SetPoint("TOPLEFT",  "WorldStateScoreFrameInset", "TOPLEFT", 4, -4);
WorldStateServerScoreFrame1:SetPoint("TOPRIGHT",  "WorldStateScoreFrameInset", "TOPRIGHT", -4, -4);
--[[for i = 2,20 do

NewFrame = CreateFrame("Frame", "WorldStateServerScoreFrame"..i, WorldStateScoreFrame, "WorldStateScoreTemplate");
--columnButton = getglobal("WorldStateScoreColumn"..i);
NewFrame:SetID(i);
NewFrame:SetPoint("TOPLEFT", "WorldStateServerScoreFrame"..(i-1), "BOTTOMLEFT", 0,0);
end]]--

	local rowFrame, prevRowFrame = _, WorldStateServerScoreFrame1;
	for i=2,MAX_WORLDSTATE_SCORE_BUTTONS do
		rowFrame = CreateFrame("FRAME", "WorldStateServerScoreFrame"..i, WorldStateScoreFrame, "WorldStateScoreTemplate");
		rowFrame:SetID(i);
		rowFrame:SetPoint("TOPLEFT",  prevRowFrame, "BOTTOMLEFT", 0, 0);
		rowFrame:SetPoint("TOPRIGHT",  prevRowFrame, "BOTTOMRIGHT", 0, 0);
		prevRowFrame = rowFrame;
	end


--[[local AnnounceFrame = CreateFrame("Frame", "PremadeAnnounceFrame");
AnnounceFrame:SetScript("OnEvent", AnnounceEvent);
AnnounceFrame:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
function AnnounceEvent(this,event,arg1)
	print("arg1"..arg1);
	local StringToSend = "PremadeCheck:";
	--Check player faction
	local Faction = UnitFactionGroup("player");
	local Factionint = 0;
	if (Faction == "Horde") then
		Factionint = 0;
	else
		Factionint = 1;
	end



	--Loop through all the servers
	for index,value in ipairs(Servers) do 
	--I guess we only care about the opposing faction

		if ( value[9] ~= Factionint ) then
			if (value[2] > 2) then
				StringToSend = StringToSend .. value[1] .. ":" .. value[2] .. " "
			end
		end

	end
	SendChatMessage(StringToSend,"BATTLEGROUND")
end]]--



local oldWorldStateScoreFrame_Update = WorldStateScoreFrame_Update;
WorldStateScoreFrame_Update = function(...)
	if (PanelTemplates_GetSelectedTab(WorldStateScoreFrame) == 4) then
		for i = 1,MAX_WORLDSTATE_SCORE_BUTTONS do
			getglobal("WorldStateServerScoreFrame"..i):Show();
			getglobal("WorldStateServerScoreFrame"..i):SetFrameStrata("MEDIUM");
			getglobal("WorldStateScoreButton"..i):Hide();
			
		end
		ProcessPlayers();
	else
		for i = 1,MAX_WORLDSTATE_SCORE_BUTTONS do
			getglobal("WorldStateServerScoreFrame"..i):Hide();
			--getglobal("WorldStateServerScoreFrame"..i):SetFrameStrata("MEDIUM");
			--getglobal("WorldStateScoreButton"..i):Hide();
		end
		oldWorldStateScoreFrame_Update();
	end
end


local oldWorldStateScoreFrame_Resize = WorldStateScoreFrame_Resize;
WorldStateScoreFrame_Resize = function(...)

	if (PanelTemplates_GetSelectedTab(WorldStateScoreFrame) == 4) then
		newWorldStateScoreFrame_Resize(...);
	else
		oldWorldStateScoreFrame_Resize(...);
	end

end





Servers = {};
CurrentTab = 0;




--SLASH_PR1, SLASH_PR2 = '/pr', '/prw'; -- 3.
--function SlashCmdList.PR(msg, editbox) -- 4.
function ProcessPlayers()
	local isArena, isRegistered = IsActiveBattlefieldArena();
	local isRatedBG = IsRatedBattleground();
	local battlefieldWinner = GetBattlefieldWinner(); 
	
	if ( isArena ) then
		-- Hide unused tabs
		WorldStateScoreFrameTab1:Hide();
		WorldStateScoreFrameTab2:Hide();
		WorldStateScoreFrameTab3:Hide();
	
		-- Hide unused columns
		WorldStateScoreFrameTeam:Hide();
		WorldStateScoreFrameDeaths:Hide();
		WorldStateScoreFrameHK:Hide();

		-- Reanchor some columns.
		WorldStateScoreFrameDamageDone:SetPoint("LEFT", "WorldStateScoreFrameKB", "RIGHT", -5, 0);
		if ( isRegistered ) then
			WorldStateScoreFrameTeam:Show();
			WorldStateScoreFrameHonorGained:Show();
			WorldStateScoreFrameHonorGainedText:SetText(SCORE_RATING_CHANGE);
			WorldStateScoreFrameHonorGained.sortType = "team";
			WorldStateScoreFrameHonorGained.tooltip = RATING_CHANGE_TOOLTIP;
			WorldStateScoreFrameTeamSkill:Show();
			WorldStateScoreFrameTeamSkillText:SetText(SCORE_TEAM_SKILL);
			WorldStateScoreFrameTeamSkill.sortType = "team";
			WorldStateScoreFrameTeamSkill.tooltip = TEAM_SKILL_TOOLTIP;
			WorldStateScoreFrameKB:SetPoint("LEFT", "WorldStateScoreFrameTeam", "RIGHT", -10, 0);
		else
			WorldStateScoreFrameHonorGained:Hide();
			WorldStateScoreFrameTeamSkill:Hide();
			WorldStateScoreFrameKB:SetPoint("LEFT", "WorldStateScoreFrameName", "RIGHT", 4, 0);
		end
	else
		-- Show Tabs
		WorldStateScoreFrameTab1:Show();
		WorldStateScoreFrameTab2:Show();
		WorldStateScoreFrameTab3:Show();
		WorldStateScoreFrameTab4:Show();
		
		WorldStateScoreFrameTeam:Hide();
		--WorldStateScoreFrameTeamSkill:Hide();
		WorldStateScoreFrameDeaths:Show();
		--WorldStateScoreFrameHK:Show();
		WorldStateScoreFrameHonorGained.sortType = "cp";
		WorldStateScoreFrameHonorGainedText:SetText(SCORE_HONOR_GAINED);
		WorldStateScoreFrameHonorGained.tooltip = HONOR_GAINED_TOOLTIP;
		WorldStateScoreFrameHKText:SetText(SCORE_HONORABLE_KILLS);
		WorldStateScoreFrameHonorGained:Show();
		-- Reanchor some columns.
		WorldStateScoreFrameDamageDone:SetPoint("LEFT", "WorldStateScoreFrameHK", "RIGHT", -5, 0);
		WorldStateScoreFrameKB:SetPoint("LEFT", "WorldStateScoreFrameName", "RIGHT", 4, 0);
	end

	--Show the frame if its hidden and there is a victor
	local battlefieldWinner = GetBattlefieldWinner(); 
	if ( battlefieldWinner ) then
		-- Show the final score frame, set textures etc.
		ShowUIPanel(WorldStateScoreFrame);
		if ( isArena ) then
			WorldStateScoreFrameLeaveButton:SetText(LEAVE_ARENA);
			WorldStateScoreFrameTimerLabel:SetText(TIME_TO_PORT_ARENA);
		else
			WorldStateScoreFrameLeaveButton:SetText(LEAVE_BATTLEGROUND);				
			WorldStateScoreFrameTimerLabel:SetText(TIME_TO_PORT);
		end
		
		WorldStateScoreFrameLeaveButton:Show();
		WorldStateScoreFrameTimerLabel:Show();
		WorldStateScoreFrameTimer:Show();

		-- Show winner
		if ( isArena ) then
			if ( isRegistered ) then
				local teamName = GetBattlefieldTeamInfo(battlefieldWinner);
				if ( teamName ) then
					WorldStateScoreWinnerFrameText:SetFormattedText(VICTORY_TEXT_ARENA_WINS, teamName);			
				else
					WorldStateScoreWinnerFrameText:SetText(VICTORY_TEXT_ARENA_DRAW);							
				end
			else
				WorldStateScoreWinnerFrameText:SetText(getglobal("VICTORY_TEXT_ARENA"..battlefieldWinner));
			end
			if ( battlefieldWinner == 0 ) then
				-- Green Team won
				WorldStateScoreWinnerFrameLeft:SetVertexColor(0.19, 0.57, 0.11);
				WorldStateScoreWinnerFrameRight:SetVertexColor(0.19, 0.57, 0.11);
				WorldStateScoreWinnerFrameText:SetVertexColor(0.1, 1.0, 0.1);	
			else		
				-- Gold Team won
				WorldStateScoreWinnerFrameLeft:SetVertexColor(0.85, 0.71, 0.26);
				WorldStateScoreWinnerFrameRight:SetVertexColor(0.85, 0.71, 0.26);
				WorldStateScoreWinnerFrameText:SetVertexColor(1, 0.82, 0);	
			end
		else
			WorldStateScoreWinnerFrameText:SetText(getglobal("VICTORY_TEXT"..battlefieldWinner));
			if ( battlefieldWinner == 0 ) then
				-- Horde won
				WorldStateScoreWinnerFrameLeft:SetVertexColor(0.52, 0.075, 0.18);
				WorldStateScoreWinnerFrameRight:SetVertexColor(0.5, 0.075, 0.18);
				WorldStateScoreWinnerFrameText:SetVertexColor(1.0, 0.1, 0.1);
			else
				-- Alliance won
				WorldStateScoreWinnerFrameLeft:SetVertexColor(0.11, 0.26, 0.51);
				WorldStateScoreWinnerFrameRight:SetVertexColor(0.11, 0.26, 0.51);
				WorldStateScoreWinnerFrameText:SetVertexColor(0, 0.68, 0.94);	
			end
		end
		WorldStateScoreWinnerFrame:Show();
	else
		WorldStateScoreWinnerFrame:Hide();
		WorldStateScoreFrameLeaveButton:Hide();
		WorldStateScoreFrameTimerLabel:Hide();
		WorldStateScoreFrameTimer:Hide();
	end
	
	-- Update buttons
	local numScores = GetNumBattlefieldScores();

	local scoreButton, buttonIcon, buttonClass, buttonName, buttonNameText, nameButton, buttonKills, buttonKillingBlows, buttonDeaths, buttonHonorGained, buttonTeamSkill, buttonFaction, columnButtonText, columnButtonIcon, buttonFactionLeft, buttonFactionRight, buttonDamage, buttonHealing, buttonTeam;
	local name, kills, killingBlows, honorableKills, deaths, honorGained, faction, rank, race, class, classToken, damageDone, healingDone;
	local teamName, teamRating, newTeamRating, teamSkill;
	local index;
	local columnData;



	-- Setup Columns
	local text, icon, tooltip, columnButton;
	local numStatColumns = GetNumBattlefieldStats();
	local columnButton, columnButtonText, columnTextButton, columnIcon;
	
	local honorGainedAnchorFrame = "WorldStateScoreFrameHealingDone";
	for i=1, MAX_NUM_STAT_COLUMNS do
		if ( i <= numStatColumns ) then
			text, icon, tooltip = GetBattlefieldStatInfo(i);
			columnButton = getglobal("WorldStateScoreColumn"..i);
			columnButtonText = getglobal("WorldStateScoreColumn"..i.."Text");
			columnButtonText:SetText(text);
			columnButton.icon = icon;
			columnButton.tooltip = tooltip;
			
			columnTextButton = getglobal("WorldStateScoreButton1Column"..i.."Text");

			if ( icon ~= "" ) then
				columnTextButton:SetPoint("CENTER", "WorldStateScoreColumn"..i, "CENTER", 6, WORLDSTATECOREFRAME_BUTTON_TEXT_OFFSET);
			else
				columnTextButton:SetPoint("CENTER", "WorldStateScoreColumn"..i, "CENTER", -1, WORLDSTATECOREFRAME_BUTTON_TEXT_OFFSET);
			end

			
			if ( i == numStatColumns ) then
				honorGainedAnchorFrame = "WorldStateScoreColumn"..i;
			end
		
			getglobal("WorldStateScoreColumn"..i):Show();
		else
			getglobal("WorldStateScoreColumn"..i):Hide();
		end
	end
	
	if ( isArena and isRegistered ) then
		WorldStateScoreFrameTeamSkill:SetPoint("LEFT", honorGainedAnchorFrame, "RIGHT", 10, 0);
		honorGainedAnchorFrame = "WorldStateScoreFrameTeamSkill";
	end
	
	-- Anchor the bonus honor gained to the last column shown
	WorldStateScoreFrameHonorGained:SetPoint("LEFT", honorGainedAnchorFrame, "RIGHT", 5, 0);
	
	-- Last button shown is what the player count anchors to
	local lastButtonShown = "WorldStateScoreButton1";
	local teamDataFailed, coords;

	if ( isArena ) then
		for i=0, 1 do
			teamName, teamRating = GetBattlefieldTeamInfo(i);
			if ( teamRating < 0 ) then
				teamDataFailed = 1;
			end
		end
		if ( isRegistered ) then
			teamName = GetBattlefieldTeamInfo(battlefieldWinner);
			if ( not teamName ) then
				teamDataFailed = 1;
			end
		end
	end
	--Prepare the data.
	local Alliance_Servers = {};
	local Horde_Servers = {};
	
	for i=1, 80 do--MAX_WORLDSTATE_SCORE_BUTTONS do
		index = i;
	
		--1			2				3			4			5		6		  7		8	  9		10			11				12
		--name, killingBlows, honorableKills, deaths, honorGained, faction, rank, race, class, classToken, damageDone, healingDone = 
		local BgStats =  {GetBattlefieldScore(index)};
		local xi = nil;
		--check if we are done
		if (not BgStats[1]) then 
		
		else
		
			--split the servername from the playername here
			PlayerName, ServerName = strsplit("-",BgStats[1]);
			--Theres no - if its your server
			if (not ServerName) then
				ServerName = GetRealmName();
			end
		
		
			--Since we store each faction seperate we need to check the faction
			if ( BgStats[6] == 0 ) then
				--Horde
				Servers = Horde_Servers;
			else
				--ally
				Servers = Alliance_Servers;
			end
			
			--Have we already found this server
			local ServerFound = false;
		
			--Now we need to check and see if weve already used this server name
			for indx,val in ipairs(Servers) do 
				local ThisServer = Servers[indx][1];
				--print("Seeking ".. ServerName .. ".Found " .. ThisServer..".");
		
		
				if (ThisServer == ServerName) then
					--Weve come across this server atleast one time already
					--So just add the new data to the old.
					--And the amount of people
					--print("Updating:"..ServerName);
					val[2] = val[2] + 1;
					val[3] = val[3]+BgStats[2];
					val[4] = val[4]+BgStats[3];
					val[5] = val[5]+BgStats[4];
					val[6] = val[6]+BgStats[5];
					val[7] = val[7]+BgStats[11];
					val[8] = val[8]+BgStats[12];
					
					
					--Also handle any BG specific data
					for j=1, MAX_NUM_STAT_COLUMNS do
						--columnButtonText = getglobal("WorldStateScoreButton"..i.."Column"..j.."Text");
						--columnButtonIcon = getglobal("WorldStateScoreButton"..i.."Column"..j.."Icon");
						if ( j <= numStatColumns ) then
							-- If there's an icon then move the icon left and format the text with an "x" in front
							local columnData = GetBattlefieldStatData(index, j);
							--Store it
							val[9+j] = val[9+j]+columnData;
						end
					end
					
					
					
					
					ServerFound = true;
					break;
				end
			
			end
		
			--If we havent already updated the data then do it here..
			if (ServerFound == false) then
				local Prep = {ServerName,1,BgStats[2],BgStats[3],BgStats[4],BgStats[5],BgStats[11],BgStats[12],BgStats[6]};
				--Now we add blanks for the extra vars
				for j=1, MAX_NUM_STAT_COLUMNS do
					if ( j <= numStatColumns ) then
						tinsert(Prep,GetBattlefieldStatData(index, j));
					end
				end
				tinsert(Servers,Prep);
			end
			Servers = nil;
		end
	
	end
	
	--Merge the data into one array
	Servers = nil;--Loose any refrence
	Servers = joinTables(Alliance_Servers,Horde_Servers);
	--Now we can calc the scrollbar and whatnot.
	numScores = #(Servers);--How many servers
	-- ScrollFrame update
	local hasScrollBar;
	if ( numScores > MAX_WORLDSTATE_SCORE_BUTTONS ) then
		hasScrollBar = 1;
		WorldStateScoreScrollFrame:Show();
	else
		WorldStateScoreScrollFrame:Hide();
        end
	FauxScrollFrame_Update(WorldStateScoreScrollFrame, numScores, MAX_WORLDSTATE_SCORE_BUTTONS, 16 );
	local scrollOffset = FauxScrollFrame_GetOffset(WorldStateScoreScrollFrame);
	--This part updates the display.
	for i=1, MAX_WORLDSTATE_SCORE_BUTTONS do
		-- Need to create an index adjusted by the scrollframe offset
		

		index = FauxScrollFrame_GetOffset(WorldStateScoreScrollFrame) + i;
		scoreButton = getglobal("WorldStateServerScoreFrame"..i);
		if ( hasScrollBar ) then
			scoreButton:SetWidth(WorldStateScoreFrame.scrollBarButtonWidth);
		else
			scoreButton:SetWidth(WorldStateScoreFrame.buttonWidth);
		end
		if ( index <= numScores ) then
		
			--Get the data out of the array
			name=Servers[index][1];
			players=Servers[index][2];
			killingBlows=Servers[index][3];
			honorableKills=Servers[index][4];
			deaths=Servers[index][5];
			honorGained=Servers[index][6];
			faction=Servers[index][9];
			damageDone= Servers[index][7];
			healingDone=Servers[index][8];
		
		
		
			buttonClass = getglobal("WorldStateServerScoreFrame"..i.."ClassButtonIcon");
			buttonName = getglobal("WorldStateServerScoreFrame"..i.."Name");
			buttonNameText = getglobal("WorldStateServerScoreFrame"..i.."NameText");
			buttonTeam =  getglobal("WorldStateServerScoreFrame"..i.."Team");
			buttonKills = getglobal("WorldStateServerScoreFrame"..i.."HonorableKills");
			buttonKillingBlows = getglobal("WorldStateServerScoreFrame"..i.."KillingBlows");
			buttonDeaths = getglobal("WorldStateServerScoreFrame"..i.."Deaths");
			buttonDamage = getglobal("WorldStateServerScoreFrame"..i.."Damage");
			buttonHealing = getglobal("WorldStateServerScoreFrame"..i.."Healing");
			buttonTeamSkill = getglobal("WorldStateServerScoreFrame"..i.."TeamSkill");
			buttonHonorGained = getglobal("WorldStateServerScoreFrame"..i.."HonorGained");
			buttonFactionLeft = getglobal("WorldStateServerScoreFrame"..i.."FactionLeft");
			buttonFactionRight = getglobal("WorldStateServerScoreFrame"..i.."FactionRight");
			
			--Get the globals for the frames we have hidden so we can update them too.
			xbuttonClass = getglobal("WorldStateScoreButton"..i.."ClassButtonIcon");
			xbuttonName = getglobal("WorldStateScoreButton"..i.."Name");
			xbuttonNameText = getglobal("WorldStateScoreButton"..i.."NameText");
			xbuttonTeam =  getglobal("WorldStateScoreButton"..i.."Team");
			xbuttonKills = getglobal("WorldStateScoreButton"..i.."HonorableKills");
			xbuttonKillingBlows = getglobal("WorldStateScoreButton"..i.."KillingBlows");
			xbuttonDeaths = getglobal("WorldStateScoreButton"..i.."Deaths");
			xbuttonDamage = getglobal("WorldStateScoreButton"..i.."Damage");
			xbuttonHealing = getglobal("WorldStateScoreButton"..i.."Healing");
			xbuttonTeamSkill = getglobal("WorldStateScoreButton"..i.."TeamSkill");
			xbuttonHonorGained = getglobal("WorldStateScoreButton"..i.."HonorGained");
			xbuttonFactionLeft = getglobal("WorldStateScoreButton"..i.."FactionLeft");
			xbuttonFactionRight = getglobal("WorldStateScoreButton"..i.."FactionRight");
			
			
			
			--[[name, killingBlows, honorableKills, deaths, honorGained, faction, rank, race, class, classToken, damageDone, healingDone = GetBattlefieldScore(index);
			if ( classToken ) then
				coords = CLASS_BUTTONS[classToken];
				buttonClass:SetTexture("Interface\\WorldStateFrame\\Icons-Classes");
				buttonClass:SetTexCoord(coords[1], coords[2], coords[3], coords[4]);
				buttonClass:Show();
			else
				buttonClass:Hide();
			end]]--
			
			buttonClass:Hide();
			buttonNameText:SetText(players.." "..name);
			xbuttonNameText:SetText(players.." "..name);
			--buttonNameText:SetText("");
			if ( not race ) then
				race = "";
			end
			if ( not class ) then
				class = "";
			end
			--buttonName.name = "";
			--buttonName.tooltip = "";
			--getglobal("WorldStateScoreButton"..i.."ClassButton").tooltip = "";
			buttonKillingBlows:SetText(killingBlows);
			buttonDamage:SetText(damageDone);
			buttonHealing:SetText(healingDone);
			
			xbuttonKillingBlows:SetText(killingBlows);
			xbuttonDamage:SetText(damageDone);
			xbuttonHealing:SetText(healingDone);
			
			
			if ( isArena ) then
				if ( isRegistered ) then
					teamName, teamRating, newTeamRating, teamSkill = GetBattlefieldTeamInfo(faction); --Moved inside the IF statements, as there was no need to call this outside of them.
					buttonTeam:SetText(teamName);
					buttonTeam:Show();
					buttonTeamSkill:SetText(teamSkill);
					buttonTeamSkill:Show();
					if ( teamDataFailed ) then
						buttonHonorGained:SetText("-------");
					else
						buttonHonorGained:SetText(tostring(newTeamRating - teamRating));
					end
					buttonHonorGained:Show();
				else
					buttonTeamSkill:Hide();
					buttonHonorGained:Hide();
					buttonTeam:Hide();
				end
				buttonKills:Hide();
				buttonDeaths:Hide();
			else
				buttonKills:SetText(honorableKills);
				buttonDeaths:SetText(deaths);
				buttonHonorGained:SetText(honorGained);
				
				xbuttonKills:SetText(honorableKills);
				xbuttonDeaths:SetText(deaths);
				xbuttonHonorGained:SetText(honorGained);
				
				buttonTeam:Hide();
				--buttonTeamSkill:Hide();
				buttonKills:Show();
				buttonDeaths:Show();
				buttonHonorGained:Show();
			end
			
			--This updates for the bg specific crap
			for j=1, MAX_NUM_STAT_COLUMNS do
				columnButtonText = getglobal("WorldStateServerScoreFrame"..i.."Column"..j.."Text");
				columnButtonIcon = getglobal("WorldStateServerScoreFrame"..i.."Column"..j.."Icon");
				
				xcolumnButtonText = getglobal("WorldStateScoreButton"..i.."Column"..j.."Text");
				xcolumnButtonIcon = getglobal("WorldStateScoreButton"..i.."Column"..j.."Icon");	
				if ( j <= numStatColumns ) then
					-- If there's an icon then move the icon left and format the text with an "x" in front
					--columnData = GetBattlefieldStatData(index, j);
					local columnData = Servers[index][9+j];
					if ( getglobal("WorldStateScoreColumn"..j).icon ~= "" ) then
						if ( columnData > 0 ) then
							columnButtonText:SetFormattedText(FLAG_COUNT_TEMPLATE, columnData);
							columnButtonIcon:SetTexture(getglobal("WorldStateScoreColumn"..j).icon..faction);
							xcolumnButtonText:SetFormattedText(FLAG_COUNT_TEMPLATE, columnData);
							xcolumnButtonIcon:SetTexture(getglobal("WorldStateScoreColumn"..j).icon..faction);
							columnButtonIcon:Show();
						else
							columnButtonText:SetText("");
							xcolumnButtonText:SetText("");
							columnButtonIcon:Hide();
						end
						
					else
						columnButtonText:SetText(columnData);
						xcolumnButtonText:SetText(columnData);
						columnButtonIcon:Hide();
					end
					columnButtonText:Show();
				else
					columnButtonText:Hide();
					columnButtonIcon:Hide();
				end
			end
			
			if ( faction ) then
			
				if ( faction == 0 ) then
				
					if ( isArena ) then
						-- Green Team 
						buttonFactionLeft:SetVertexColor(0.19, 0.57, 0.11);
						buttonFactionRight:SetVertexColor(0.19, 0.57, 0.11);
						buttonNameText:SetVertexColor(0.1, 1.0, 0.1);	
					else
						-- Horde
						buttonFactionLeft:SetVertexColor(0.52, 0.075, 0.18);
						buttonFactionRight:SetVertexColor(0.5, 0.075, 0.18);
						buttonNameText:SetVertexColor(1.0, 0.1, 0.1);
					end
					
				else
				
					if ( isArena ) then
						-- Gold Team 
						buttonFactionLeft:SetVertexColor(0.85, 0.71, 0.26);
						buttonFactionRight:SetVertexColor(0.85, 0.71, 0.26);
						buttonNameText:SetVertexColor(1, 0.82, 0);	
					else
						-- Alliance 
						buttonFactionLeft:SetVertexColor(0.11, 0.26, 0.51);
						buttonFactionRight:SetVertexColor(0.11, 0.26, 0.51);
						buttonNameText:SetVertexColor(0, 0.68, 0.94);	
					end
					
				end
				
				if ( ( not isArena ) and ( name == UnitName("player") ) ) then
					buttonNameText:SetVertexColor(1.0, 0.82, 0);
				end
				
				buttonFactionLeft:Show();
				buttonFactionRight:Show();
			else
				buttonFactionLeft:Hide();
				buttonFactionRight:Hide();
			end
			
			
			
			
			lastButtonShown = scoreButton:GetName();
			scoreButton:Show();
		else
			scoreButton:Hide();
		end
	end

	-- Count number of players on each side
	local numHorde = 0;
	local numAlliance = 0;
	for i=1, numScores do
		--name, killingBlows, honorableKills, deaths, honorGained, faction, rank, race, class = GetBattlefieldScore(i);	
		faction=Servers[i][9];
		if ( faction ) then
			if ( faction == 0 ) then
				numHorde = numHorde + 1;
			else
				numAlliance = numAlliance + 1;
			end
		end
	end
	
	
	if isRatedBG then
		averageHorde = averageHorde/max(numHorde,1);
		averageAlliance = averageAlliance/max(numAlliance ,1);
		local ourAverage = averageHorde;
		local theirAverage = averageAlliance;
		local factionGroup = UnitFactionGroup("player");
		if factionGroup == "Alliance" then
			ourAverage, theirAverage = theirAverage, ourAverage;
		end
		WorldStateScoreFrame.teamAverageRating:Show();
		WorldStateScoreFrame.enemyTeamAverageRating:Show();
		WorldStateScoreFrame.teamAverageRating:SetFormattedText(BATTLEGROUND_YOUR_AVERAGE_RATING, ourAverage);
		WorldStateScoreFrame.enemyTeamAverageRating:SetFormattedText(BATTLEGROUND_ENEMY_AVERAGE_RATING, theirAverage);
	else
		WorldStateScoreFrame.teamAverageRating:Hide();
		WorldStateScoreFrame.enemyTeamAverageRating:Hide();
	end
	
	
	
	
	-- Set count text and anchor team count to last button shown
	WorldStateScorePlayerCount:Show();
	if ( numHorde > 0 and numAlliance > 0 ) then
		WorldStateScorePlayerCount:SetText(format(PLAYER_COUNT_ALLIANCE, numAlliance).." / "..format(PLAYER_COUNT_HORDE, numHorde));
	elseif ( numAlliance > 0 ) then
		WorldStateScorePlayerCount:SetFormattedText(PLAYER_COUNT_ALLIANCE, numAlliance);
	elseif ( numHorde > 0 ) then
		WorldStateScorePlayerCount:SetFormattedText(PLAYER_COUNT_HORDE, numHorde);
	else
		WorldStateScorePlayerCount:Hide();
	end
	if ( isArena ) then
		WorldStateScorePlayerCount:Hide();
	end

	WorldStateScorePlayerCount:SetPoint("TOPLEFT", lastButtonShown, "BOTTOMLEFT", 15, -6);
	WorldStateScoreBattlegroundRunTime:SetText(TIME_ELAPSED.." "..SecondsToTime(GetBattlefieldInstanceRunTime()/1000, 1));
	WorldStateScoreBattlegroundRunTime:SetPoint("TOPRIGHT", lastButtonShown, "BOTTOMRIGHT", -20, -7);
	
end

function joinTables(t1, t2)  
        for k,v in ipairs(t2) do table.insert(t1, v) end return t1  
end  


function newWorldStateScoreFrame_Resize()
	local isArena, isRegistered = IsActiveBattlefieldArena();
	local columns = WORLDSTATESCOREFRAME_BASE_COLUMNS;
	local scrollBar = 37;
	local name;
	--if ( not width ) then

	 local width = WorldStateScoreFrameName:GetWidth() + WorldStateScoreFrameClass:GetWidth();

		if ( isArena ) then
			columns = 3;
			if ( isRegistered ) then
				columns = 5;
				width = width + WorldStateScoreFrameTeam:GetWidth();
			else
				width = width + 43;
			end
		end

	columns = columns + GetNumBattlefieldStats();
	
		width = width + (columns*WORLDSTATESCOREFRAME_COLUMN_SPACING);

		if ( WorldStateScoreScrollFrame:IsShown() ) then
			width = width + scrollBar;
		end
	--end
	
	WorldStateScoreFrame:SetWidth(width);
	
	WorldStateScoreFrame.scrollBarButtonWidth = WorldStateScoreFrame:GetWidth() - 165;
	WorldStateScoreFrame.buttonWidth = WorldStateScoreFrame:GetWidth() - 137;
	WorldStateScoreScrollFrame:SetWidth(WorldStateScoreFrame.scrollBarButtonWidth);

	-- Position Column data horizontally
	local buttonTeam, buttonTeamSkill, buttonKills, buttonKillingBlows, buttonDeaths, buttonDamage, buttonHealing, buttonHonorGained, buttonReturnedIcon, buttonCapturedIcon;
	for i=1, MAX_WORLDSTATE_SCORE_BUTTONS do
		if ( isRegistered ) then
			buttonTeam = getglobal("WorldStateServerScoreFrame"..i.."Team");
			buttonTeamSkill = getglobal("WorldStateServerScoreFrame"..i.."TeamSkill");
		end
		
		buttonKills = getglobal("WorldStateServerScoreFrame"..i.."HonorableKills");
		buttonKillingBlows = getglobal("WorldStateServerScoreFrame"..i.."KillingBlows");
		buttonDeaths = getglobal("WorldStateServerScoreFrame"..i.."Deaths");
		buttonDamage = getglobal("WorldStateServerScoreFrame"..i.."Damage");
		buttonHealing = getglobal("WorldStateServerScoreFrame"..i.."Healing");
		buttonHonorGained = getglobal("WorldStateServerScoreFrame"..i.."HonorGained");
		if ( i == 1 ) then
			if ( isRegistered ) then
				buttonTeam:SetPoint("LEFT", "WorldStateScoreFrameTeam", "LEFT", 0, WORLDSTATECOREFRAME_BUTTON_TEXT_OFFSET);
				buttonTeamSkill:SetPoint("CENTER", "WorldStateScoreFrameTeamSkill", "CENTER", 0, WORLDSTATECOREFRAME_BUTTON_TEXT_OFFSET);
			end
			buttonKills:SetPoint("CENTER", "WorldStateScoreFrameHK", "CENTER", 0, WORLDSTATECOREFRAME_BUTTON_TEXT_OFFSET);
			buttonKillingBlows:SetPoint("CENTER", "WorldStateScoreFrameKB", "CENTER", 0, WORLDSTATECOREFRAME_BUTTON_TEXT_OFFSET);
			buttonDeaths:SetPoint("CENTER", "WorldStateScoreFrameDeaths", "CENTER", 0, WORLDSTATECOREFRAME_BUTTON_TEXT_OFFSET);
			buttonDamage:SetPoint("CENTER", "WorldStateScoreFrameDamageDone", "CENTER", 0, WORLDSTATECOREFRAME_BUTTON_TEXT_OFFSET);
			buttonHealing:SetPoint("CENTER", "WorldStateScoreFrameHealingDone", "CENTER", 0, WORLDSTATECOREFRAME_BUTTON_TEXT_OFFSET);
			buttonHonorGained:SetPoint("CENTER", "WorldStateScoreFrameHonorGained", "CENTER", 0, WORLDSTATECOREFRAME_BUTTON_TEXT_OFFSET);
			for j=1, MAX_NUM_STAT_COLUMNS do
				getglobal("WorldStateServerScoreFrame"..i.."Column"..j.."Text"):SetPoint("CENTER", getglobal("WorldStateScoreColumn"..j), "CENTER", 0,  WORLDSTATECOREFRAME_BUTTON_TEXT_OFFSET);
			end
		else
			if ( isRegistered ) then
				buttonTeam:SetPoint("LEFT", "WorldStateServerScoreFrame"..(i-1).."Team", "LEFT", 0,  -SCORE_BUTTON_HEIGHT);
				buttonTeamSkill:SetPoint("CENTER", "WorldStateServerScoreFrame"..(i-1).."TeamSkill", "CENTER", 0, -SCORE_BUTTON_HEIGHT);
			end
			buttonKills:SetPoint("CENTER", "WorldStateServerScoreFrame"..(i-1).."HonorableKills", "CENTER", 0, -SCORE_BUTTON_HEIGHT);
			buttonKillingBlows:SetPoint("CENTER", "WorldStateServerScoreFrame"..(i-1).."KillingBlows", "CENTER", 0, -SCORE_BUTTON_HEIGHT);
			buttonDeaths:SetPoint("CENTER", "WorldStateServerScoreFrame"..(i-1).."Deaths", "CENTER", 0, -SCORE_BUTTON_HEIGHT);
			buttonDamage:SetPoint("CENTER", "WorldStateServerScoreFrame"..(i-1).."Damage", "CENTER", 0, -SCORE_BUTTON_HEIGHT);
			buttonHealing:SetPoint("CENTER", "WorldStateServerScoreFrame"..(i-1).."Healing", "CENTER", 0, -SCORE_BUTTON_HEIGHT);
			buttonHonorGained:SetPoint("CENTER", "WorldStateServerScoreFrame"..(i-1).."HonorGained", "CENTER", 0, -SCORE_BUTTON_HEIGHT);
			for j=1, MAX_NUM_STAT_COLUMNS do
				getglobal("WorldStateServerScoreFrame"..i.."Column"..j.."Text"):SetPoint("CENTER", "WorldStateServerScoreFrame"..(i-1).."Column"..j.."Text", "CENTER", 0, -SCORE_BUTTON_HEIGHT);
			end
		end
	end
	return width;
end